#include "ringbuffer.h"

ringbuffer::ringbuffer()
{
    head = buffer.begin();
    tail = buffer.begin();
}

int ringbuffer::write(char c)
{
    if(head - tail == MAX_BUFFER_SIZE) {
        return 0;
    }

    if(head == buffer.end()) {
        head = buffer.begin();
    }

    *head = c;
    head++;

    return 1;
}

int ringbuffer::read(char& c)
{
    if(head - tail == 0) {
        return 0;
    }

    if(tail == buffer.end()) {
        tail = buffer.begin();
    }

    c = *tail;
    tail++;

    return 1;
}
